require = GLOBAL.require
local TUNING = GLOBAL.TUNING
local GetPlayer = GLOBAL.GetPlayer
local Combat = require "components/combat"
local follower = require "components/follower"
local harvestable = require "components/harvestable"
local ccanattack = Combat.CanAttack
local GetPlayer = GLOBAL.GetPlayer
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local ACTIONS = GLOBAL.ACTIONS
local Vector3 = GLOBAL.Vector3
local distsq = GLOBAL.distsq
local GetWorld = GLOBAL.GetWorld
local Prefabs = GLOBAL.Prefabs
local Transform = GLOBAL.Transform
local Physics = GLOBAL.Physics
local AnimState = GLOBAL.AnimState
local FRAMES = GLOBAL.FRAMES
local DEGREES = GLOBAL.DEGREES
local SpawnPrefab = GLOBAL.SpawnPrefab
local TheCamera = GLOBAL.TheCamera
local seg_time = 30
local day_segs = 10
local dusk_segs = 4
local night_segs = 2
local day_time = seg_time * day_segs
local dusk_time = seg_time * dusk_segs
local night_time = seg_time * night_segs
local total_day_time = seg_time*16
local TheSim = GLOBAL.TheSim
local SpawnPrefab = GLOBAL.SpawnPrefab
local GetSeasonManager = GLOBAL.GetSeasonManager
local SEASONS = GLOBAL.SEASONS
local GetClock = GLOBAL.GetClock
local GetWorld = GLOBAL.GetWorld

local continuous_mode = true
local rogEnabled = GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)
local swEnabled = GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) 

local function DynamicMusicPostInit(self,inst)
	self.stingeractive = false	
	
	self.inst:ListenForEvent( "dusktime", function(it, data) 
            if self.enabled then
				if continuous_mode then
					self.stingeractive = true
				end
				self:StopPlayingBusy()
				self.inst:DoTaskInTime(8, function(inst)
					if not GetWorld():IsCave() then
						if GetClock():IsDusk() then
							self.inst.SoundEmitter:KillSound("busy")	
							self.is_busy = false
							self:PlayTheme()
							if continuous_mode then
								self.stingeractive = false
								self:OnStartBusy()
							end
						end
					else
						if continuous_mode then
							self.stingeractive = false
							self:OnStartBusy()
						end
					end
				end)
            end   
        end, GetWorld())      

    self.inst:ListenForEvent( "daytime", function(it, data) 
            if self.enabled then 
				if continuous_mode then
					self.stingeractive = true
				end
				self:StopPlayingBusy()
				self.inst:DoTaskInTime(8, function(inst)
					if not GetWorld():IsCave() then
						if GetClock():IsDay() then
							self.inst.SoundEmitter:KillSound("busy")	
							self.is_busy = false
							self:PlayTheme()
							if continuous_mode then
								self.stingeractive = false
								self:OnStartBusy()
							end
						end
					else
						if continuous_mode then
							self.stingeractive = false
							self:OnStartBusy()
						end
					end
				end)
            end
        end, GetWorld())      

    self.inst:ListenForEvent( "nighttime", function(it, data) 
			if self.enabled then 
				self.inst:DoTaskInTime(2, function(inst)
					if not GetWorld():IsCave() then
						if GetClock():IsNight() then
							self.inst.SoundEmitter:KillSound("busy")	
							self.is_busy = false	
							self:PlayTheme()
							if continuous_mode then
								self:OnStartBusy()
							end
						end
					else
						if continuous_mode then
							self:OnStartBusy()
						end
					end
				end)
			end
		end, GetWorld())
		
		
	function self:StartPlayingBusy()
		if GetWorld():IsRuins() then
			self.inst.SoundEmitter:PlaySound( "dontstarve/music/music_work_ruins", "busy")
		elseif GetWorld():IsCave() then
			self.inst.SoundEmitter:PlaySound( "dontstarve/music/music_work_cave", "busy")
		elseif GetClock():IsDay() then
			self:PlayTheme()
		elseif GetClock():IsDusk() then
			self:PlayTheme()
		elseif GetClock():IsNight() then
			self:PlayTheme()
		end
		self.inst.SoundEmitter:SetParameter( "busy", "intensity", 0 )
	end	
	
	self.inst:ListenForEvent("mountboat", function(it, data)
		self.inst.SoundEmitter:KillSound("busy")	
		self.is_busy = false	
		self:PlayTheme()
		if continuous_mode then
			self:OnStartBusy()
		end	
    end)
	
	inst:ListenForEvent("dismountboat", function(it, data)
		self.inst.SoundEmitter:KillSound("busy")	
		self.is_busy = false	
		self:PlayTheme()
		if continuous_mode then
			self:OnStartBusy()
		end
    end)
	
	function self:OnStartBusy()
		if not self.enabled then return end
		if not self.busy_started then
			self.busy_started = true
			self:StartPlayingBusy()
		end		
		self.busy_timeout = 15	
		if not self.is_busy or continuous_mode then
			self.is_busy = true
			if not self.playing_danger and not self.stingeractive then
				self.inst.SoundEmitter:SetParameter( "busy", "intensity", 1 )
			end
		end		
	end
	
	function self:StopPlayingDanger()
		self.inst.SoundEmitter:KillSound("danger")
		self.playing_danger = false
		if continuous_mode then
			self:OnStartBusy()
		end
	end
	
	function self:PlayTheme()
		self.season = GetSeasonManager().current_season
		if not GetPlayer():HasTag("aquatic") then
			if self.season == SEASONS.WET then
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_work_season_2", "busy")
			elseif self.season == SEASONS.GREEN then
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_work_season_3", "busy")
			elseif self.season == SEASONS.DRY then
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_work_season_4", "busy")
			else
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_work_season_1", "busy")
			end
		else
			if GetClock():IsDay() then
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_sailing_day", "busy")
			else
				self.inst.SoundEmitter:PlaySound( "dontstarve_DLC002/music/music_sailing_night", "busy")
			end	
		end
		if continuous_mode then
			self.busy_started = true
		end
	end
	
	function self:OnUpdate(dt)

		if self.danger_timeout and self.danger_timeout > 0 then
			self.danger_timeout = self.danger_timeout - dt
			if self.danger_timeout <= 0 then
				self:StopPlayingDanger()
			end
		end
		
		if not continuous_mode and self.busy_timeout and self.busy_timeout > 0 then
			self.busy_timeout = self.busy_timeout - dt
			if self.busy_timeout <= 0 then
				self:StopPlayingBusy()
				self.is_busy = false
			end
		end
		
	end
	
	if continuous_mode and not self.stingeractive then
		self.is_busy = true
	end
end
AddComponentPostInit("dynamicmusic", DynamicMusicPostInit)